/**
 * OpenWireFormat code
 *
 *
 * NOTE!: This file is autogenerated - do not modify!
 *        if you need to make a change, please see the Groovy scripts in the
 *        activemq-openwire module
 */

package org.activemq.transport.openwire.io;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import org.activemq.message.*;
import org.activemq.io.*;
import org.activemq.io.impl.*;
import org.activemq.transport.openwire.OpenWireFormatSupport;

/**
 * AUTOGENERATED WireFormat OpenWire
 *
 * @version $Revision: 1.1 $
 */
public class OpenWireFormat extends OpenWireFormatSupport {

    private Map marshallersByTypeName = new HashMap();


    protected transient AbstractPacketMarshaller transactionInfoMarshaller = new TransactionInfoMarshaller();

    protected transient AbstractPacketMarshaller sessionInfoMarshaller = new SessionInfoMarshaller();

    protected transient AbstractPacketMarshaller cachedValueMarshaller = new CachedValueMarshaller();

    protected transient AbstractPacketMarshaller capacityInfoMarshaller = new CapacityInfoMarshaller();

    protected transient AbstractPacketMarshaller messageAckMarshaller = new MessageAckMarshaller();

    protected transient AbstractPacketMarshaller producerInfoMarshaller = new ProducerInfoMarshaller();

    protected transient AbstractPacketMarshaller intResponseReceiptMarshaller = new IntResponseReceiptMarshaller();

    protected transient AbstractPacketMarshaller receiptMarshaller = new ReceiptMarshaller();

    protected transient AbstractPacketMarshaller activeMQTextMessageMarshaller = new ActiveMQTextMessageMarshaller();

    protected transient AbstractPacketMarshaller durableUnsubscribeMarshaller = new DurableUnsubscribeMarshaller();

    protected transient AbstractPacketMarshaller consumerInfoMarshaller = new ConsumerInfoMarshaller();

    protected transient AbstractPacketMarshaller responseReceiptMarshaller = new ResponseReceiptMarshaller();

    protected transient AbstractPacketMarshaller keepAliveMarshaller = new KeepAliveMarshaller();

    protected transient AbstractPacketMarshaller activeMQObjectMessageMarshaller = new ActiveMQObjectMessageMarshaller();

    protected transient AbstractPacketMarshaller activeMQStreamMessageMarshaller = new ActiveMQStreamMessageMarshaller();

    protected transient AbstractPacketMarshaller activeMQMessageMarshaller = new ActiveMQMessageMarshaller();

    protected transient AbstractPacketMarshaller activeMQMapMessageMarshaller = new ActiveMQMapMessageMarshaller();

    protected transient AbstractPacketMarshaller wireFormatInfoMarshaller = new WireFormatInfoMarshaller();

    protected transient AbstractPacketMarshaller brokerAdminCommandMarshaller = new BrokerAdminCommandMarshaller();

    protected transient AbstractPacketMarshaller brokerInfoMarshaller = new BrokerInfoMarshaller();

    protected transient AbstractPacketMarshaller activeMQBytesMessageMarshaller = new ActiveMQBytesMessageMarshaller();

    protected transient AbstractPacketMarshaller connectionInfoMarshaller = new ConnectionInfoMarshaller();

    protected transient AbstractPacketMarshaller cleanupConnectionInfoMarshaller = new CleanupConnectionInfoMarshaller();

    protected transient AbstractPacketMarshaller xATransactionInfoMarshaller = new XATransactionInfoMarshaller();

    protected transient AbstractPacketMarshaller capacityInfoRequestMarshaller = new CapacityInfoRequestMarshaller();

    public OpenWireFormat() {

    marshallersByTypeName.put("org.activemq.message.TransactionInfo", transactionInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.SessionInfo", sessionInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.CachedValue", cachedValueMarshaller);

    marshallersByTypeName.put("org.activemq.message.CapacityInfo", capacityInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.MessageAck", messageAckMarshaller);

    marshallersByTypeName.put("org.activemq.message.ProducerInfo", producerInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.IntResponseReceipt", intResponseReceiptMarshaller);

    marshallersByTypeName.put("org.activemq.message.Receipt", receiptMarshaller);

    marshallersByTypeName.put("org.activemq.message.ActiveMQTextMessage", activeMQTextMessageMarshaller);

    marshallersByTypeName.put("org.activemq.message.DurableUnsubscribe", durableUnsubscribeMarshaller);

    marshallersByTypeName.put("org.activemq.message.ConsumerInfo", consumerInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.ResponseReceipt", responseReceiptMarshaller);

    marshallersByTypeName.put("org.activemq.message.KeepAlive", keepAliveMarshaller);

    marshallersByTypeName.put("org.activemq.message.ActiveMQObjectMessage", activeMQObjectMessageMarshaller);

    marshallersByTypeName.put("org.activemq.message.ActiveMQStreamMessage", activeMQStreamMessageMarshaller);

    marshallersByTypeName.put("org.activemq.message.ActiveMQMessage", activeMQMessageMarshaller);

    marshallersByTypeName.put("org.activemq.message.ActiveMQMapMessage", activeMQMapMessageMarshaller);

    marshallersByTypeName.put("org.activemq.message.WireFormatInfo", wireFormatInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.BrokerAdminCommand", brokerAdminCommandMarshaller);

    marshallersByTypeName.put("org.activemq.message.BrokerInfo", brokerInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.ActiveMQBytesMessage", activeMQBytesMessageMarshaller);

    marshallersByTypeName.put("org.activemq.message.ConnectionInfo", connectionInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.CleanupConnectionInfo", cleanupConnectionInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.XATransactionInfo", xATransactionInfoMarshaller);

    marshallersByTypeName.put("org.activemq.message.CapacityInfoRequest", capacityInfoRequestMarshaller);

    }

    public Packet readPacket(int firstByte, DataInput dataIn) throws IOException {
        switch (firstByte) {

            case 1 :
                return readPacket(dataIn, transactionInfoMarshaller);


            case 2 :
                return readPacket(dataIn, sessionInfoMarshaller);


            case 3 :
                return readPacket(dataIn, cachedValueMarshaller);


            case 4 :
                return readPacket(dataIn, capacityInfoMarshaller);


            case 5 :
                return readPacket(dataIn, messageAckMarshaller);


            case 6 :
                return readPacket(dataIn, producerInfoMarshaller);


            case 7 :
                return readPacket(dataIn, intResponseReceiptMarshaller);


            case 8 :
                return readPacket(dataIn, receiptMarshaller);


            case 9 :
                return readPacket(dataIn, activeMQTextMessageMarshaller);


            case 10 :
                return readPacket(dataIn, durableUnsubscribeMarshaller);


            case 11 :
                return readPacket(dataIn, consumerInfoMarshaller);


            case 12 :
                return readPacket(dataIn, responseReceiptMarshaller);


            case 13 :
                return readPacket(dataIn, keepAliveMarshaller);


            case 14 :
                return readPacket(dataIn, activeMQObjectMessageMarshaller);


            case 15 :
                return readPacket(dataIn, activeMQStreamMessageMarshaller);


            case 16 :
                return readPacket(dataIn, activeMQMessageMarshaller);


            case 17 :
                return readPacket(dataIn, activeMQMapMessageMarshaller);


            case 18 :
                return readPacket(dataIn, wireFormatInfoMarshaller);


            case 19 :
                return readPacket(dataIn, brokerAdminCommandMarshaller);


            case 20 :
                return readPacket(dataIn, brokerInfoMarshaller);


            case 21 :
                return readPacket(dataIn, activeMQBytesMessageMarshaller);


            case 22 :
                return readPacket(dataIn, connectionInfoMarshaller);


            case 23 :
                return readPacket(dataIn, cleanupConnectionInfoMarshaller);


            case 24 :
                return readPacket(dataIn, xATransactionInfoMarshaller);


            case 25 :
                return readPacket(dataIn, capacityInfoRequestMarshaller);


        }
        return null;
    }

    protected  AbstractPacketMarshaller getMarshaller(Packet packet) {
        return (AbstractPacketMarshaller) marshallersByTypeName.get(packet.getClass().getName());
    }
}
