/**
 * Marshalling code for Open Wire Format for SessionInfo
 *
 *
 * NOTE!: This file is autogenerated - do not modify!
 *        if you need to make a change, please see the Groovy scripts in the
 *        activemq-openwire module
 */

package org.activemq.transport.openwire.io;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.activemq.message.*;
import org.activemq.io.*;
import org.activemq.io.impl.*;
import org.activemq.transport.openwire.OpenWirePacketMarshallerSupport;

/**
 * AUTOGENERATED Marshaller for OpenWire command SessionInfo
 *
 * @version $Revision: 1.1 $
 */
public class SessionInfoMarshaller extends OpenWirePacketMarshallerSupport {

    /**
     * Return the type of Packet
     *
     * @return integer representation of the type of Packet
     */
    public int getPacketType() {
        return 2;
    }

    /**
     * @return a new Packet instance
     */
    public Packet createPacket() {
        return new SessionInfo();
    }

    /**
     * build a Packet instance from the data input stream
     *
     * @param packet A Packet object
     * @param dataIn the data input stream to build the packet from
     * @throws IOException
     */
    public void buildPacket(Packet packet, DataInput dataIn) throws IOException {
        super.buildPacket(packet, dataIn);
        SessionInfo info = (SessionInfo) packet;
        info.setSessionMode(dataIn.readInt());
        info.setSessionId(dataIn.readShort());
        info.setClientId(readString(dataIn));
        info.setStarted(dataIn.readBoolean());
        info.setStartTime(dataIn.readLong());

    }

    /**
     * Write a Packet instance to data output stream
     *
     * @param packet  the instance to be seralized
     * @param dataOut the output stream
     * @throws IOException thrown if an error occurs
     */
    public void writePacket(Packet packet, DataOutput dataOut) throws IOException {
        super.writePacket(packet, dataOut);
        SessionInfo info = (SessionInfo) packet;
        dataOut.writeInt(info.getSessionMode());
        dataOut.writeShort(info.getSessionId());
        writeString(info.getClientId(), dataOut);
        dataOut.writeBoolean(info.isStarted());
        dataOut.writeLong(info.getStartTime());

    }
}
